"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const libs_1 = require("./libs");
const infrastructure_components_1 = require("infrastructure-components");
const ssr_config_1 = require("./types/ssr-config");
const iso_config_1 = require("./types/iso-config");
const path = require('path');
const cmd = require('node-cmd');
/**
 *
 * @param configFilePath
 */
function build(configFilePath) {
    return __awaiter(this, void 0, void 0, function* () {
        //const webpack = require('webpack');
        const config = yield libs_1.loadConfiguration(configFilePath);
        //const config = await loadConfiguration(configFilePath);
        console.log("config-type: ", config.type);
        // && scripts build webpack.config.server.js && cp -rf ./dist/js/ ./build/server/assets/
        if (config.type === infrastructure_components_1.ConfigTypes.LOWLEVEL_SPA || config.type === infrastructure_components_1.ConfigTypes.LOWLEVEL_SERVER) {
            yield libs_1.runWebpack(libs_1.complementWebpackConfig(config.webpackConfig));
        }
        else if (config.type === infrastructure_components_1.ConfigTypes.SSR && config.ssrConfig !== undefined) {
            const { ssrConfig } = config;
            yield ssr_config_1.buildSsr(ssrConfig);
        }
        else if (config.type === infrastructure_components_1.ConfigTypes.ISOMORPHIC && config.ssrConfig !== undefined && config.isoConfig !== undefined) {
            const { isoConfig, ssrConfig } = config;
            yield ssr_config_1.buildSsr(yield iso_config_1.isoToSsr(configFilePath, isoConfig, ssrConfig));
        }
        else {
            // TODO implement the build process for higher level APIs
        }
    });
}
exports.build = build;
;
//# sourceMappingURL=build.js.map