"use strict";
/**
 * TODO LEGACY PART
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const infrastructure_components_1 = require("infrastructure-components");
const libs_1 = require("../libs");
const sls_config_1 = require("./sls-config");
exports.resolveAssetsPath = (ssrConfig) => {
    const path = require('path');
    const assetsPath = path.resolve(infrastructure_components_1.getBuildPath(ssrConfig.serverConfig, ssrConfig.buildPath), ssrConfig.assetsPath);
    return !assetsPath.endsWith("/") ? assetsPath + "/" : assetsPath;
};
function buildSsr(ssrConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        const fs = require('fs');
        const path = require('path');
        // prepare the client(')s(') config(s)
        const clientWpConfig = exports.prepareClientConfig(ssrConfig.clientConfig, ssrConfig.buildPath);
        console.log("buildSsr, server Config BEFORE: ", ssrConfig.serverConfig);
        // preapre the server config
        const serverWpConfig = libs_1.complementWebpackConfig(infrastructure_components_1.toServerWebpackConfig(ssrConfig.serverConfig, ssrConfig.buildPath));
        // build the clients
        if (Array.isArray(clientWpConfig)) {
            yield Promise.all(clientWpConfig.map((c) => __awaiter(this, void 0, void 0, function* () { return yield libs_1.runWebpack(c); })));
        }
        else {
            yield libs_1.runWebpack(clientWpConfig);
        }
        const dataLayerWpConfig = exports.prepareDataLayerConfig(ssrConfig.datalayerConfig, ssrConfig.buildPath);
        // build the data layers
        if (Array.isArray(dataLayerWpConfig)) {
            yield Promise.all(dataLayerWpConfig.map((c) => __awaiter(this, void 0, void 0, function* () { return yield libs_1.runWebpack(c); })));
        }
        else {
            yield libs_1.runWebpack(dataLayerWpConfig);
        }
        console.log("buildSsr, server Config: ", serverWpConfig);
        // build the server
        yield libs_1.runWebpack(serverWpConfig);
        const assetsPath = exports.resolveAssetsPath(ssrConfig);
        console.log("assetsPath: ", assetsPath);
        // copy the client apps to the assets-folder
        if (Array.isArray(ssrConfig.clientConfig)) {
            yield Promise.all(ssrConfig.clientConfig.map((c) => __awaiter(this, void 0, void 0, function* () { return yield libs_1.copyAssets(infrastructure_components_1.getBuildPath(c, ssrConfig.buildPath), assetsPath); })));
        }
        else {
            libs_1.copyAssets(infrastructure_components_1.getBuildPath(ssrConfig.clientConfig, ssrConfig.buildPath), assetsPath);
        }
    });
}
exports.buildSsr = buildSsr;
function startSsr(ssrConfig, slsConfig = {}, keepSlsYaml = false) {
    return __awaiter(this, void 0, void 0, function* () {
        // start the sls-config
        sls_config_1.startSlsOffline(sls_config_1.toSlsConfig(ssrConfig.stackName, ssrConfig.serverConfig, ssrConfig.buildPath, ssrConfig.assetsPath, ssrConfig.region, slsConfig), keepSlsYaml);
    });
}
exports.startSsr = startSsr;
function deploySsr(ssrConfig, slsConfig = {}, keepSlsYaml = false) {
    return __awaiter(this, void 0, void 0, function* () {
        // prepare the sls-config
        // start the sls-config
        yield sls_config_1.deploySls(sls_config_1.toSlsConfig(ssrConfig.stackName, ssrConfig.serverConfig, ssrConfig.buildPath, ssrConfig.assetsPath, ssrConfig.region, slsConfig), keepSlsYaml);
        const staticBucketName = libs_1.getStaticBucketName(ssrConfig.stackName, ssrConfig.assetsPath, process.env.STAGE);
        // copy the client apps to the assets-folder
        console.log("start S3 Sync");
        if (Array.isArray(ssrConfig.clientConfig)) {
            yield Promise.all(ssrConfig.clientConfig.map((c) => __awaiter(this, void 0, void 0, function* () { return yield libs_1.s3sync(ssrConfig.region, staticBucketName, infrastructure_components_1.getBuildPath(c, ssrConfig.buildPath)); })));
        }
        else {
            libs_1.s3sync(ssrConfig.region, staticBucketName, infrastructure_components_1.getBuildPath(ssrConfig.clientConfig, ssrConfig.buildPath));
        }
    });
}
exports.deploySsr = deploySsr;
/**
 *
 * @param clientConfig
 * @param buildPath
 *
 * return one (or an array of) Webpack Client Configs
 */
exports.prepareClientConfig = (clientConfig, buildPath) => {
    return Array.isArray(clientConfig) ?
        clientConfig.map(c => libs_1.complementWebpackConfig(infrastructure_components_1.toClientWebpackConfig(c, buildPath))) :
        libs_1.complementWebpackConfig(infrastructure_components_1.toClientWebpackConfig(clientConfig, buildPath));
};
exports.prepareDataLayerConfig = (clientConfig, buildPath) => {
    return Array.isArray(clientConfig) ?
        clientConfig.map(c => libs_1.complementWebpackConfig(infrastructure_components_1.toServerWebpackConfig(c, buildPath))) :
        libs_1.complementWebpackConfig(infrastructure_components_1.toServerWebpackConfig(clientConfig, buildPath));
};
//# sourceMappingURL=ssr-config.js.map